"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var FormData = require('form-data');
var fetch = require('isomorphic-fetch');
var IPFSClient = /** @class */ (function () {
    function IPFSClient(ipfsUrl) {
        this.baseUrl = ipfsUrl;
    }
    Object.defineProperty(IPFSClient.prototype, "ipfsUrl", {
        get: function () {
            return this.baseUrl;
        },
        enumerable: true,
        configurable: true
    });
    IPFSClient.prototype.cat = function (hash) {
        return __awaiter(this, void 0, void 0, function () {
            var params, response, msg, result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        params = new FormData();
                        params.append('arg', Buffer.from(hash));
                        return [4 /*yield*/, fetch(this.baseUrl + "/cat", {
                                body: params,
                                method: 'POST'
                            })];
                    case 1:
                        response = _a.sent();
                        if (!(response.status !== 200)) return [3 /*break*/, 3];
                        return [4 /*yield*/, response.text()];
                    case 2:
                        msg = _a.sent();
                        throw Error("An error occurred getting the file " + hash + ": " + msg);
                    case 3: return [4 /*yield*/, response.json()];
                    case 4:
                        result = _a.sent();
                        return [2 /*return*/, result];
                }
            });
        });
    };
    IPFSClient.prototype.addString = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            var params, buffer, res, msg, json;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        params = new FormData();
                        buffer = Buffer.from(data);
                        params.append('file', buffer);
                        return [4 /*yield*/, fetch(this.baseUrl + "/add", {
                                body: params,
                                method: 'POST'
                            })];
                    case 1:
                        res = _a.sent();
                        if (!(res.status !== 200)) return [3 /*break*/, 3];
                        return [4 /*yield*/, res.text()];
                    case 2:
                        msg = _a.sent();
                        throw Error("An error occurred adding these data to ipfs: " + msg);
                    case 3: return [4 /*yield*/, res.json()];
                    case 4:
                        json = _a.sent();
                        return [2 /*return*/, json.Hash];
                }
            });
        });
    };
    IPFSClient.prototype.pinHash = function (hash) {
        return __awaiter(this, void 0, void 0, function () {
            var params, response, msg;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!hash) {
                            throw Error("You must provide an ipfs Hash - you provided " + hash + " instead");
                        }
                        params = new FormData();
                        params.append('arg', Buffer.from(hash));
                        return [4 /*yield*/, fetch(this.baseUrl + "/pin/add", {
                                body: params,
                                method: 'POST'
                            })];
                    case 1:
                        response = _a.sent();
                        if (!(response.status !== 200)) return [3 /*break*/, 3];
                        return [4 /*yield*/, response.text()];
                    case 2:
                        msg = _a.sent();
                        throw Error("An error occurred pinning the file " + hash + ": " + msg);
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    IPFSClient.prototype.addAndPinString = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            var hash;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.addString(data)];
                    case 1:
                        hash = _a.sent();
                        return [4 /*yield*/, this.pinHash(hash)];
                    case 2:
                        _a.sent();
                        return [2 /*return*/, hash];
                }
            });
        });
    };
    return IPFSClient;
}());
exports.IPFSClient = IPFSClient;
//# sourceMappingURL=ipfsClient.js.map