"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var BN = require("bn.js");
var graphql_tag_1 = require("graphql-tag");
var operators_1 = require("rxjs/operators");
var dao_1 = require("./dao");
var scheme_1 = require("./scheme");
var utils_1 = require("./utils");
var Queue = /** @class */ (function () {
    function Queue(context, id, dao) {
        this.context = context;
        this.id = id;
        this.dao = dao;
        this.context = context;
    }
    /**
     * Queue.search(context, options) searches for queue entities
     * @param  context an Arc instance that provides connection information
     * @param  options the query options, cf. IQueueQueryOptions
     * @return         an observable of Queue objects
     */
    Queue.search = function (context, options, apolloQueryOptions) {
        if (options === void 0) { options = {}; }
        if (apolloQueryOptions === void 0) { apolloQueryOptions = {}; }
        if (!options.where) {
            options.where = {};
        }
        var where = '';
        for (var _i = 0, _a = Object.keys(options.where); _i < _a.length; _i++) {
            var key = _a[_i];
            if (options[key] === undefined) {
                continue;
            }
            if (key === 'dao' || key === 'votingMaching' || key === 'scheme') {
                var option = options[key];
                utils_1.isAddress(option);
                options[key] = option.toLowerCase();
            }
            where += key + ": \"" + options[key] + "\"\n";
        }
        // use the following query once https://github.com/daostack/subgraph/issues/217 is resolved
        var query = graphql_tag_1.default(templateObject_1 || (templateObject_1 = __makeTemplateObject(["query QueueSearch\n      {\n        gpqueues ", " {\n          id\n          dao {\n            id\n          }\n          scheme {\n            id\n            address\n            name\n            numberOfBoostedProposals\n            numberOfPreBoostedProposals\n            numberOfQueuedProposals\n          }\n        }\n      }\n    "], ["query QueueSearch\n      {\n        gpqueues ", " {\n          id\n          dao {\n            id\n          }\n          scheme {\n            id\n            address\n            name\n            numberOfBoostedProposals\n            numberOfPreBoostedProposals\n            numberOfQueuedProposals\n          }\n        }\n      }\n    "])), utils_1.createGraphQlQuery(options, where));
        var itemMap = function (item) {
            // we must filter explictly by name as the subgraph does not return the name
            return new Queue(context, item.id, new dao_1.DAO(context, item.dao.id));
        };
        return context.getObservableList(query, itemMap, apolloQueryOptions);
    };
    Queue.prototype.fetchState = function (apolloQueryOptions) {
        if (apolloQueryOptions === void 0) { apolloQueryOptions = {}; }
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.state(apolloQueryOptions).pipe(operators_1.first()).toPromise()];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    Queue.prototype.state = function (apolloQueryOptions) {
        var _this = this;
        if (apolloQueryOptions === void 0) { apolloQueryOptions = {}; }
        var query = graphql_tag_1.default(templateObject_2 || (templateObject_2 = __makeTemplateObject(["query QueueState\n      {\n        gpqueue (id: \"", "\") {\n          id\n          dao {\n            id\n          }\n          scheme {\n            ...SchemeFields\n          }\n          votingMachine\n          threshold\n        }\n      }\n      ", "\n    "], ["query QueueState\n      {\n        gpqueue (id: \"", "\") {\n          id\n          dao {\n            id\n          }\n          scheme {\n            ...SchemeFields\n          }\n          votingMachine\n          threshold\n        }\n      }\n      ", "\n    "])), this.id, scheme_1.Scheme.fragments.SchemeFields);
        var itemMap = function (item) {
            if (!item) {
                throw Error("No gpQueue with id " + _this.id + " was found");
            }
            var threshold = utils_1.realMathToNumber(new BN(item.threshold));
            var scheme = scheme_1.Scheme.itemMap(_this.context, item.scheme);
            return {
                dao: item.dao.id,
                id: item.id,
                name: scheme.name,
                scheme: scheme,
                threshold: threshold,
                votingMachine: item.votingMachine
            };
        };
        return this.context.getObservableObject(query, itemMap, apolloQueryOptions);
    };
    return Queue;
}());
exports.Queue = Queue;
var templateObject_1, templateObject_2;
//# sourceMappingURL=queue.js.map