import BN = require('bn.js');
import { Arc } from '../arc';
import { ITransaction, ITransactionReceipt } from '../operation';
import { IProposalBaseCreateOptions, Proposal } from '../proposal';
import { Address } from '../types';
export interface IContributionRewardExt {
    beneficiary: Address;
    externalTokenReward: BN;
    externalToken: Address;
    ethReward: BN;
    nativeTokenReward: BN;
    periods: number;
    periodLength: number;
    reputationReward: BN;
    alreadyRedeemedNativeTokenPeriods: number;
    alreadyRedeemedReputationPeriods: number;
    alreadyRedeemedExternalTokenPeriods: number;
    alreadyRedeemedEthPeriods: number;
    reputationChangeLeft: BN;
    nativeTokenRewardLeft: BN;
    ethRewardLeft: BN;
    externalTokenRewardLeft: BN;
}
export interface IProposalCreateOptionsCRExt extends IProposalBaseCreateOptions {
    beneficiary: Address;
    nativeTokenReward?: BN;
    reputationReward?: BN;
    ethReward?: BN;
    externalTokenReward?: BN;
    externalTokenAddress?: Address;
    proposer: Address;
}
export declare enum IProposalType {
    ContributionReward = "ContributionRewardExt"
}
export declare function createProposalTransaction(context: Arc, options: IProposalCreateOptionsCRExt): Promise<ITransaction>;
export declare function createProposalTransactionMap(context: Arc, options: IProposalCreateOptionsCRExt): (receipt: ITransactionReceipt) => Proposal;
