import { Arc } from '../arc';
import { ITransaction, ITransactionReceipt } from '../operation';
import { IProposalBaseCreateOptions, Proposal } from '../proposal';
import { Address } from '../types';
export interface IGenericSchemeInfo {
    id: string;
    contractToCall: Address;
    votingMachine: Address;
}
export interface IGenericScheme {
    id: string;
    contractToCall: Address;
    callData: string;
    executed: boolean;
    returnValue: string;
}
export interface IProposalCreateOptionsGS extends IProposalBaseCreateOptions {
    callData?: string;
    value?: number;
}
export declare enum IProposalType {
    GenericScheme = "GenericScheme"
}
export declare function createProposalTransaction(context: Arc, options: IProposalCreateOptionsGS): Promise<ITransaction>;
/**
 * map the transaction receipt of the createTransaction call to a nice result
 * @param  options  the options passed to the createProposal call
 * @param  context an Arc instance
 * @return         [description]
 */
export declare function createProposalTransactionMap(context: Arc, options: IProposalCreateOptionsGS): (receipt: ITransactionReceipt) => Promise<Proposal>;
