import { Arc } from '../arc';
import { ITransaction, ITransactionReceipt } from '../operation';
import { IProposalBaseCreateOptions, Proposal } from '../proposal';
import { Address } from '../types';
export interface ISchemeRegistrar {
    id: string;
    schemeToRegister: Address;
    schemeToRegisterPermission: string;
    schemeToRemove: string;
    decision: number;
    schemeRegistered: boolean;
    schemeRemoved: boolean;
}
export interface IProposalCreateOptionsSR extends IProposalBaseCreateOptions {
    permissions?: string;
    schemeToRegister?: Address;
}
export declare enum IProposalType {
    SchemeRegistrarAdd = "SchemeRegistrarAdd",
    SchemeRegistrarEdit = "SchemeRegistrarEdit",
    SchemeRegistrarRemove = "SchemeRegistrarRemove"
}
export declare function createProposalTransaction(context: Arc, options: IProposalCreateOptionsSR): Promise<ITransaction>;
export declare function createTransactionMap(context: Arc, options: IProposalCreateOptionsSR): (receipt: ITransactionReceipt) => Proposal;
