import { Observable } from 'rxjs';
import { Arc, IApolloQueryOptions } from './arc';
import { Proposal } from './proposal';
import { ICommonQueryOptions, IStateful } from './types';
export interface ITagState {
    id: string;
    numberOfProposals: number;
    proposals?: Proposal[];
}
export interface ITagQueryOptions extends ICommonQueryOptions {
    where?: {
        id?: string;
        proposal?: string;
    };
}
export declare class Tag implements IStateful<ITagState> {
    context: Arc;
    static fragments: {
        TagFields: import("graphql").DocumentNode;
    };
    /**
     * Tag.search(context, options) searches for stake entities
     * @param  context an Arc instance that provides connection information
     * @param  options the query options, cf. ITagQueryOptions
     * @return         an observable of Tag objects
     */
    static search(context: Arc, options?: ITagQueryOptions, apolloQueryOptions?: IApolloQueryOptions): Observable<Tag[]>;
    id: string | undefined;
    coreState: ITagState | undefined;
    constructor(context: Arc, idOrOpts: string | ITagState);
    state(apolloQueryOptions?: IApolloQueryOptions): Observable<ITagState>;
    setState(opts: ITagState): void;
    fetchState(apolloQueryOptions?: IApolloQueryOptions): Promise<ITagState>;
}
